uxn/etc/asma-test.sh

73 lines
1.8 KiB
Bash
Raw Normal View History

2021-05-16 09:20:04 +00:00
#!/bin/sh
set -e
cd "$(dirname "${0}")/.."
rm -rf asma-test
mkdir asma-test
expect_failure() {
2021-10-07 21:30:19 +00:00
cat > asma-test/in.tal
2021-10-07 21:39:53 +00:00
echo asma-test/in.tal | bin/uxncli asma-test/asma.rom > asma-test/out.rom 2> asma-test/asma.log
2021-10-07 21:30:19 +00:00
if ! grep -qF "${1}" asma-test/asma.log; then
2021-08-10 18:23:53 +00:00
echo "error: asma didn't report error ${1} in faulty code"
2021-10-07 21:30:19 +00:00
cat asma-test/asma.log
2021-08-10 18:23:53 +00:00
fi
}
2021-05-16 09:20:04 +00:00
echo 'Assembling asma with uxnasm'
2021-10-07 21:30:19 +00:00
bin/uxnasm projects/software/asma.tal asma-test/asma.rom > asma-test/uxnasm.log
for F in $(find projects -path projects/library -prune -false -or -type f -name '*.tal' | sort); do
2021-05-16 09:20:04 +00:00
echo "Comparing assembly of ${F}"
2021-10-07 21:30:19 +00:00
UASM_BASE="asma-test/uxnasm-$(basename "${F%.tal}")"
if ! bin/uxnasm "${F}" "${UASM_BASE}.rom" 2> "${UASM_BASE}.log"; then
2021-05-16 09:20:04 +00:00
echo "error: uxnasm failed to assemble ${F}"
2021-10-07 21:30:19 +00:00
cat "${UASM_BASE}.log"
2021-05-16 09:20:04 +00:00
exit 1
fi
2021-10-07 21:30:19 +00:00
xxd "${UASM_BASE}.rom" > "${UASM_BASE}.hex"
2021-05-16 09:20:04 +00:00
2021-10-07 21:30:19 +00:00
ASMA_BASE="asma-test/asma-$(basename "${F%.tal}")"
echo "${F}" | bin/uxncli asma-test/asma.rom > "${ASMA_BASE}.rom" 2> "${ASMA_BASE}.log"
if ! grep -qF 'bytes of heap used' "${ASMA_BASE}.log"; then
2021-05-16 09:20:04 +00:00
echo "error: asma failed to assemble ${F}, while uxnasm succeeded"
2021-10-07 21:30:19 +00:00
cat "${ASMA_BASE}.log"
2021-05-16 09:20:04 +00:00
exit 1
fi
2021-10-07 21:30:19 +00:00
xxd "${ASMA_BASE}.rom" > "${ASMA_BASE}.hex"
2021-05-16 09:20:04 +00:00
2021-10-07 21:30:19 +00:00
diff -u "${UASM_BASE}.hex" "${ASMA_BASE}.hex"
2021-05-16 09:20:04 +00:00
done
expect_failure 'Invalid hexadecimal: $defg' <<'EOD'
|1000 $defg
EOD
expect_failure 'Invalid hexadecimal: #defg' <<'EOD'
|1000 #defg
EOD
expect_failure 'Address not in zero page: .hello' <<'EOD'
|1000 @hello
.hello
EOD
expect_failure 'Address outside range: ,hello' <<'EOD'
|1000 @hello
|2000 ,hello
EOD
expect_failure 'Label not found: hello' <<'EOD'
hello
EOD
expect_failure 'Macro already exists: %abc' <<'EOD'
%abc { def }
%abc { ghi }
EOD
expect_failure 'Memory overwrite: SUB' <<'EOD'
|2000 ADD
|1000 SUB
EOD
expect_failure 'Recursion level too deep:' <<'EOD'
%me { you }
%you { me }
|1000 me
EOD
2021-05-16 09:20:04 +00:00
echo 'All OK'